        PROGRAM QUIVER                  !        1/7/89
C
C      QUIVER (KWIV'ER), V., N.
C       1: SHAKE; SHIVER; TREMBLE. [CF. OE CWIFERLICE ACTIVELY]
C       2: TO SHAKE WITH A SLIGHT BUT RAPID MOTION.
C
C                  KEITH E LAIDIG    YALE UNIVERSITY 1988
C
C       Changed No of atoms variable NMA from 20 to 25; HZ, Mai 1992
C       cutoff reduced from 50 to 20 cm-1 for low frequencies; HZ
C       N(14) and O(16) atomic weights added; HZ
C       Changed Variable BEXC(JJ,L) to RBEXC(JJ,L) in formatted write
C       Statement 390; HZ
C
        IMPLICIT DOUBLE PRECISION (A-H,O-Z)
        PARAMETER (MNA = 25)
        PARAMETER (MQ = 3*MNA)
c       PARAMETER (MMOL = 6)
        PARAMETER (MMOL = 15)
        PARAMETER (MTEM = 6)
        PARAMETER (NNREL = 15)
        CHARACTER*80 FILE,TITLE
        DIMENSION C(MQ),E(MQ,MQ),F(MQ),A(MMOL,MQ),V(MQ,MQ),AI(3,3)
        DIMENSION VM(MQ,MQ,MMOL),X(MMOL,MQ),Y(MMOL,MQ),Z(MMOL,MQ)
        dimension xmem(mna),ymem(mna),zmem(mna),atw(100)
        integer*2 mwt(mna)
        DIMENSION W(3,3)
        DIMENSION RMASFA(NNREL),TRFA(NNREL),IREL(2,MMOL)
C
C    TEMPERATURE DEPENDENT VALUES
C
        DIMENSION TEMS(MTEM),TRRULE(NNREL,MTEM),PRODFA(NNREL,MTEM)
        DIMENSION TMASS(MMOL),PTL(MMOL),TMASFA(MMOL),PMU(MMOL,MTEM)
        DIMENSION SUMNU(MMOL),SSUMNU(MMOL),SUMU(MMOL,MTEM)
        DIMENSION BEXC(MMOL,MTEM),U(MQ),ONIUM(MMOL)
        DIMENSION RBEXC(NNREL,MTEM),DSUMU(NNREL,MTEM)
        DIMENSION QRAT(NNREL,MTEM),EFFR(NNREL,MTEM)
C
C    VARIOUS CONSTANTS TO BE USED
C    CM IS THE SPEED OF LIGHT IN CM/SEC
C    EM IS THE CONVERSION FACTOR FROM ERG TO KCAL/MOL
C    HM IS PLANCK'S CONSTANT
C    HBC IS PLANCK'S CONSTANT/BOLTZMANN'S CONSTANT (CM*K)
C
        DATA HM/6.625E-27/,CM/2.998E10/,EM/1.440E13/,HBC/1.4387/
C    set up masses
        do 5 i=1,100
        atw(i)=0.0
5       continue
        atw(1) = 1.00783
        atw(2) = 2.0141
        atw(3) = 3.01605
        atw(12) = 12.000
        atw(13) = 13.00335
        atw(14) = 14.0031
        atw(16) = 15.9949
C       
C    READ IN INPUT AND OUTPUT FILE NAMES
C
        WRITE (6,10)
10      FORMAT(' NAME OF INPUT FILE ',$)
        READ (5,20) FILE
20      FORMAT(A80)
        OPEN (10,STATUS='OLD',FILE=FILE)
C
        WRITE (6,30)
30      FORMAT(' NAME OF OUTPUT FILE ',$)
        READ (5,20) FILE
        OPEN (20,STATUS='NEW',CARRIAGECONTROL='LIST',FILE=FILE)
C
C    SHORT OR LONG OUTPUT?
C
        WRITE (6,40)
40      FORMAT(' SHORT OR LONG OUTPUT? [0/1] ',$)
        READ (5,*) IPR
C
C    SCALING FACTOR FOR FORCE CONSTANTS IS SET AT 1.0D0  (DB)
C
       SCALE = 1.0D0
      WRITE (6,44)
44    FORMAT(' SCALING FACTOR? [1.0] ',$)
      READ (5,*) SCALE
C
        READ (10,20) TITLE
        WRITE(20,20) TITLE
C
      WRITE (20,45) SCALE
45    FORMAT(/,' FREQUENCIES ARE SCALED BY  ',F9.6)
C
C   READ IN NUMBER OF INPUT MOLECULES
C
        READ (10,*)  NMOL
C
C    LOOP OVER ISOTOPOMERS
C
        DO 330 IMOL = 1,NMOL
C
C    READ IN TITLE, NUMBER OF ATOMS, MASS AND CARTESIAN COORDINATES
C    FOR EACH ATOM
C
         WRITE (20,50)
50    FORMAT('     ================================================== '
     1)
         READ (10,20) TITLE
         WRITE (20,60) TITLE(1:60)
60       FORMAT(/,'ISOTOPOMER NAME ',A60)
         IF (IPR.EQ.1.and.imol.eq.1) WRITE (20,70)
70       FORMAT(/,'          X              Y              Z ')
C
C    LOOP OVER NUMBER OF ATOMS
C INPUT FORMAT MODIFIED TO READ .COR FORMAT (DB)
C
          if(imol.eq.1) then
         READ (10,*)  NAT
         DO 90 I = 1,NAT
c         II = 3*I
c        READ (10,170) A(IMOL,II),X(IMOL,I),Y(IMOL,I),Z(IMOL,I)
c          READ (10,80) A(IMOL,II),Xmem(I),Ymem(I),Zmem(I)
c         IF (IPR .EQ. 1) WRITE (20,80)
c       1     A(IMOL,II),X(IMOL,I),Y(IMOL,I),Z(IMOL,I)
C
C INPUT FORMAT MODIFIED TO READ STANDARD ORIENTATION FROM G92
C
           READ (10,79) Xmem(I),Ymem(I),Zmem(I)
          x(imol,i) = xmem(i)
          y(imol,i) = ymem(i)
          z(imol,i) = zmem(i)
          IF (IPR .EQ. 1) WRITE (20,80)
     1    Xmem(I), Ymem(I), Zmem(I)
79        FORMAT(13X,3F12.6)
80        FORMAT(4F15.8)
90       CONTINUE
        endif
        read (10,92)(mwt(j),j=1,nat)
92      format(30i)
        IF (IPR.EQ.1) WRITE (20,96)
96      format(/,'          Weights')
        do 95 i=1,nat
          x(imol,i) = xmem(i)
          y(imol,i) = ymem(i)
          z(imol,i) = zmem(i)
          II = 3*I
        if (atw(mwt(i)).eq.0) then
          WRITE (6,98) mwt(i)
98        FORMAT(' What is the exact mass of isotope ',i2, ' ?  ',$)
          READ (5,*) atw(mwt(i))
        endif
        A(IMOL,II) = atw(mwt(i))
          IF (IPR .EQ. 1) WRITE (20,97) i,atw(mwt(i))
97      format(i5,f12.5)
95      continue
C
C    LOAD THE MASSES INTO A VECTOR OF 3*NAT IN ORDER
C    TO FACILITATE MASS WEIGHTING OF POTENTIAL ENERGY
C    MATRIX
C
         DO 100 I = 3,3*NAT,3
          A(IMOL,I-1) = A(IMOL,I)
          A(IMOL,I-2) = A(IMOL,I)
100      CONTINUE
C
C    SCALING FACTOR FOR FORCE CONSTANTS IS SET AT 1.0D0
C     COMMENTED OUT BY DB. SCALING IS IMPLEMENTED FOR THE FINAL FREQUENCIES
C
C         IF (IMOL .EQ. 1) THEN
C          SCALE = 1.0D0
CC      WRITE (20,35) SCALE
C110       FORMAT(/,' SCALING FACTOR FOR FORCE CONSTANT MATRIX ',F9.6)
C         END IF
C
C    READ IN POTENTIAL ENERGY MATRIX OF SECOND DERRIVATIVE FORCE
C    CONSTANTS
C
         IF (IMOL .EQ. 1) THEN
          DO 130 K=1,INT((3*NAT+4)/5)
           KSTART=(5*K)-4
           DO 130 I=KSTART,3*NAT
            READ (10,120,ERR=130) IN,(V(I,J),J=KSTART,KSTART+4)
120         FORMAT(I4,5E14.0)
130       CONTINUE
C
C    FILL IN SYMMETRIC MATRIX
C
          DO 140 I=1,3*NAT
           DO 140 J=1,I
            V(J,I)=V(I,J)
140       CONTINUE
C
C     WE CONVERT HARTREES PER SQUARE BOHR TO MILLIDYNES PER ANGSTROM
C     (AND ONE COULD SCALE THE FORCE CONSTANT MATRIX HERE )
C
C       GIVEN:  1 BOHR IS 5.29167E-01 ANGSTROM
C               1 HARTREE IS 4.35942E-11 ERG
C               1 ANGSTROM IS 1.0E-08 CENTIMETER
C               1 ERG IS 1 DYNE * 1 CM
C
          GDF = 435.942 / ( 5.29167 * 5.29167 )
          DO 150 I = 1, 3*NAT
           DO 150 J = 1, I
            V(I,J) = V(I,J) * GDF
C
C   SCALING IS IMPLEMENTED BELOW.
C
C            V(I,J) = V(I,J) * GDF * SCALE
            V(J,I) = V(I,J)
150       CONTINUE
         END IF
C
C    READ IN TEMPERATURES TO BE USED IN THIS RUN
C
         IF (IMOL .EQ. 1) THEN
          READ (10,160) NOTEM
160       FORMAT(I4)
          READ (10,170) (TEMS(IT),IT=1,NOTEM)
170       FORMAT(6F10.4)
         END IF
C
C    TRANSFER FORCE CONSTANTS TO MATRIX VM AND MASS WEIGHT THEM
C
         DO 180 I = 1,3*NAT
          DO 180 J = 1,3*NAT
           VM(J,I,IMOL) = V(J,I)/(DSQRT(A(IMOL,I))*DSQRT(A(IMOL,J)))
180      CONTINUE
C
C    DIAGONLIZE THE MASS WEIGHTED CARTESIAN COORDINATES
C    THIS PRODUCES THE EIGENVALUES AND EIGENVECTORS
C    WHICH CORRESPOND TO THE FREQUENCIES (AFTER CORRECTION)
C    AND THE NORMAL MODE VIBRATIONAL DISPLACEMENTS, RESPECTIVELY
C
         CALL HDIAG (VM(1,1,IMOL),3*NAT,MQ,0,E)
C
C    CONVERT EIGENVALUES TO WAVENUMBERS
C
C    THE CONVERSION FACTOR USED IS
C
         CNV = SQRT(5.8890E-07)
C
C    THE FREQUENCIES ARE SCALED BY THE INPUT SCALING FACTOR (DB)
C
         NIGNORE=0
         DO 200 I = 1,3*NAT
          F(I) = SCALE*SIGN((DSQRT(ABS(VM(I,I,IMOL)))/CNV),VM(I,I,IMOL))
          DO 190 J = 1,3*NAT
           C(J) = E(J,I)/DSQRT(A(IMOL,J))
190       CONTINUE
C
C    USE A CUTOFF OF 50 CM-1 TO SEPARATE THE SIX NEAR ZERO
C    FREQUENCIES FROM THE OTHER 3N-6
C
          IF (F(I) .GT. 20.0 .OR. F(I) .LT. -50.0) THEN
           IF (IPR .EQ. 1) WRITE (20,210) F(I)
           IF (IPR .EQ. 1) WRITE (20,220) (C(K),K=1,3*NAT)
          ELSE 
           IF (IPR .EQ. 1) WRITE (20,215) F(I)
           NIGNORE=NIGNORE+1
          END IF
200      CONTINUE
210      FORMAT(/' FREQUENCY OF ', F15.5, ' 1/CM ')
215      FORMAT(' SMALL FREQUENCY OF ', F15.5, ' 1/CM WAS IGNORED')
220      FORMAT(' NORMAL COORDINATE ',/,3(3X,3F7.4))
C
C    WARNING IF THERE ARE NOT 6 FREQUENCIES IGNORED
C
      IF (NIGNORE .NE. 6) WRITE (20,225) NIGNORE
225   FORMAT (/,' CAUTION! ',I2,' SMALL FREQUENCIES WERE IGNORED!')
C
C    GET MOMENTS OF INERTIA FOR THE MOLECULE
C
C    ZERO OUT ARRAY AI
C
         DO 230 I = 1,3
          DO 230 J = 1,3
           AI(J,I) = 0.0D0
230      CONTINUE
C
C    CONVERT CARTESIAN COORDINATES INTO ATOMIC UNITS
C    CONVERSION FACTOR IS 1.889727 BOHR/ANGSTROM
C
         ATB = 1.889727
C
         DO 240 J = 1,NAT
          X(IMOL,J) = X(IMOL,J)*ATB
          Y(IMOL,J) = Y(IMOL,J)*ATB
          Z(IMOL,J) = Z(IMOL,J)*ATB
240      CONTINUE
C
C    LOAD UP ARRAY AI FOR DIAGONALIZATION
C
         DO 250 J=1,NAT
          AI(1,1) = AI(1,1) + A(IMOL,3*J)*(Y(IMOL,J)**2+Z(IMOL,J)**2)
          AI(2,2) = AI(2,2) + A(IMOL,3*J)*(X(IMOL,J)**2+Z(IMOL,J)**2)
          AI(3,3) = AI(3,3) + A(IMOL,3*J)*(X(IMOL,J)**2+Y(IMOL,J)**2)
          AI(1,2) = AI(1,2) - A(IMOL,3*J)*X(IMOL,J)*Y(IMOL,J)
          AI(1,3) = AI(1,3) - A(IMOL,3*J)*X(IMOL,J)*Z(IMOL,J)
          AI(2,3) = AI(2,3) - A(IMOL,3*J)*Y(IMOL,J)*Z(IMOL,J)
250      CONTINUE
C
C    FILL IN SYMMETRIC OFF-DIAGONAL ELEMENTS
C
         AI(2,1) = AI(1,2)
         AI(3,1) = AI(1,3)
         AI(3,2) = AI(2,3)
C
C    DIAGONALIZE AI
C    EIGENVALUES RETURNED ARE THE MOMEMNTS OF INTERTIA AND
C    THE EIGENVECTORS REPRESENT THE INTERTIAL FRAME
C
         CALL HDIAG(AI,3,3,0,W)
C
         WRITE (20,260) (AI(J,J), J=1,3)
260      FORMAT (/,' MOMENTS OF INERTIA'/' IX = ', 1PE12.4,
     1                               '  IY = ', 1PE12.4,
     2                               '  IZ = ', 1PE12.4 )
C
C    DETERMINE THE TOTAL MASS
C
C    SET PTL EQUAL TO ONE
C
         PTL(IMOL) = 1.0D0
         DO 270 I = 1,NAT
          TMASS(IMOL) = TMASS(IMOL) + A(IMOL,3*I)
          PTL(IMOL) = PTL(IMOL) + 1.5*LOG(A(IMOL,3*I))
270      CONTINUE
C%%%
         WRITE(20,280) TMASS(IMOL)
280      FORMAT(/,' TOTAL MASS ',F8.4)
C
C   DETERMINE THE MASS FACTOR FOR EACH MOLECULE
C   !!!AVOID DIVIDE BY ZERO FOR LINEAR MOLECULES!!!
C
         IF (AI(1,1) .EQ. 0.0) AI(1,1) = 1.0D0
         IF (AI(2,2) .EQ. 0.0) AI(2,2) = 1.0D0
         IF (AI(3,3) .EQ. 0.0) AI(3,3) = 1.0D0
C
         TMASFA(IMOL) = (AI(1,1)*AI(2,2)*AI(3,3))**0.5
     1              *(TMASS(IMOL))**1.5
C%%%
C
C    TRAP OUT SMALL AND NEGATIVE FREQUENCIES HERE
C
         DO 290 I = 1,3*NAT
          IF (F(I) .GT.  20.0) SUMNU(IMOL) = SUMNU(IMOL) + F(I)
          IF (F(I) .LT. -50.0) ONIUM(IMOL) = -F(I)
          SSUMNU(IMOL) = SSUMNU(IMOL) + SIGN(F(I)**2,F(I))
290      CONTINUE
C
C    NOW FACTOR IN APPROPRIATE CONVERSION FACTORS TO THE
C    ZERO POINT ENERGY
C
         SUMNU(IMOL) = SUMNU(IMOL)*0.5*HM*CM*EM
C
         WRITE (20,300) SUMNU(IMOL)
300      FORMAT(/,' THE ZERO-POINT ENERGY IS ',F8.4,' KCAL/MOLE')
C
C    FOR EACH TEMPERATURE INPUT,
C    1) CALCULATE THE PRODUCT SUM OF ONE MINUS EXP(-MU(I)) OVER THE
C       NORMAL MODES; GIVEN MU = H*DV(I)/K*T OR 1.4387*DV(I)/T.
C    2) CALCULATE THE SUM OF MU/2.0 OVER THE NORMAL MODES
C
         DO 320 L = 1,NOTEM
          BEXC(IMOL,L) = 1.0D0
          PMU(IMOL,L) = 1.0D0
          SUMU(IMOL,L) = 1.0D0
          DO 310 I = 1,3*NAT
           U(I) = HBC*F(I)/TEMS(L)
           IF (F(I) .GT. 20.0) BEXC(IMOL,L) = BEXC(IMOL,L)*(1.0-EXP
     1 (-U(I)))
           IF (F(I) .GT. 20.0) PMU(IMOL,L) = PMU(IMOL,L)+LOG(U(I))
           IF (F(I) .GT. 20.0) SUMU(IMOL,L) = SUMU(IMOL,L) + U(I)
310       CONTINUE
C%%%
C
320      CONTINUE
C
C    READ IN FURTHER ISOTOPOMERS
C
330     CONTINUE
C
C    LOOP OVER NUMBER OF ISOTOPIC RELATIONSHIPS
C
340     READ (10,160) NIREL
C
C    LOOP OVER THE RELATIONSHIPS OF INTEREST
C
        DO 440 JJ = 1,NIREL
C
         READ (10,350) (IREL(J,JJ),J=1,2)
350      FORMAT(2I4)
         WRITE(20,50)
         WRITE(20,360) IREL(2,JJ),IREL(1,JJ)
360      FORMAT(/,' RELATIONSHIPS BETWEEN ISOTOPOMERS ',I4,'    /',I4)
C
C    FIND TELLER-REDLICH PRODUCT RULE RATIO, RATIO OF MASS FACTORS,
C    FUNCTION OF SUMMED LOGS OF ATOMIC WEIGHTS AND SUMMED LOGS OF
C    FREQUENCIES
C
         RMASFA(JJ) = TMASFA(IREL(2,JJ))/TMASFA(IREL(1,JJ))
         TRFA(JJ) = RMASFA(JJ)*EXP(PTL(IREL(1,JJ))-PTL(IREL(2,JJ)))
C%%@@
C
C   LOOP OVER TEMPERATURES OF INTEREST
C
         DO 440 L = 1,NOTEM
C
C     RBEXC IS THE EXCITATION FACTOR
C
          PRODFA(JJ,L) = EXP(PMU(IREL(2,JJ),L)-PMU(IREL(1,JJ),L))
          RBEXC(JJ,L) = BEXC(IREL(1,JJ),L)/BEXC(IREL(2,JJ),L)
          DSUMU(JJ,L) = 0.5*(SUMU(IREL(1,JJ),L) - SUMU(IREL(2,JJ),L))
C
C    TELLER-REDLICH PRODUCT RULE
C
          TRRULE(JJ,L) = PRODFA(JJ,L)/TRFA(JJ)
C
C     EXP(DSUMU) IS THE ZERO-POINT FACTOR
C
          QRAT(JJ,L) = RMASFA(JJ)*RBEXC(JJ,L)*EXP(DSUMU(JJ,L))
C
C     EFFER IS THE BIGELEISEN-MAYER FUNCTION : (S2/S1)F
C
          EFFR(JJ,L) = PRODFA(JJ,L)*RBEXC(JJ,L)*EXP(DSUMU(JJ,L))
C%%
          WRITE(20,370) TEMS(L)
370       FORMAT(/,' TEMPERATURE                     ',F9.4)
          WRITE(20,380) PRODFA(JJ,L)
380       FORMAT(' RATIO OF PRODUCT OF FREQUENCIES ',E15.8)
          WRITE(20,390) RBEXC(JJ,L)
390       FORMAT(' EXCITATION FACTOR               ',E15.8)
          WRITE(20,400) EXP(DSUMU(JJ,L))
400       FORMAT(' ZERO-POINT DIFFERENCE FACTOR    ',E15.8)
          WRITE(20,410) TRRULE(JJ,L)
410       FORMAT(' TELLER-REDLICH PRODUCT RATIO    ',E15.8)
          WRITE(20,420) EFFR(JJ,L)
420       FORMAT(' BIGELEISEN-MAYER FUNCTION',/,
     1           ' (S2/S1)F                        ',E15.8)
C     WRITE(20,114) QRAT(JJ,L)
430       FORMAT(' RATIO OF PARTITION FUNCTIONS ',E15.8)
C
440     CONTINUE
C
450     STOP ' END OF QUIVER ANALYSIS '
C
        END
C
        SUBROUTINE HDIAG ( A, N, NDIM, IEGEN, EIVR )
        IMPLICIT NONE
C*****
C     THIS ROUTINE IS A MODIFICATION OF HDIAG, WRITTEN AT MIT,
C     THAT USES THE JACOBI METHOD.  THIS ROUTINE USES A VARIABLE
C     THRESHOLD JACOBI METHOD.  IT GIVES VERY GOOD EIGENVALUES
C     AND EIGENVECTORS AND IS MUCH FASTER.  THIS IS JACVAT.
C*****
      INTEGER I, I2, IEGEN, IFLAG, II, IROW, J, JCOL, JCOL1, JJ
      INTEGER K, N, NDIM, NU
      DOUBLE PRECISION A(NDIM,NDIM), AII, AIJ, AJJ, AMIN, ATOP, AVGF, C
      DOUBLE PRECISION D, DSTOP, EIVR(NDIM,NDIM), S, T, TEMP, THRSH, U
C*****
        IF ( N .LE. 1 ) THEN
         EIVR(1,1) = 1.0
         RETURN
        ENDIF
        IF ( IEGEN .EQ. 0 ) THEN
         DO 20 J = 1, N
          DO 10 I = 1, N
           EIVR(I,J) = 0.0
10        CONTINUE
          EIVR(J,J) = 1.0
20       CONTINUE
        ENDIF
C*****
C     FIND THE ABSOLUTELY LARGEST ELEMENT OF A
C*****
        ATOP = 0.0
        DO 30 I = 1, N
         DO 30 J = I, N
          IF ( ATOP .LT. ABS(A(I,J)) ) ATOP = ABS(A(I,J))
30      CONTINUE
        IF ( ATOP .LE. 0.0 ) RETURN
C*****
C     CALCULATE THE STOPPING CRITERION -- DSTOP
C*****
        AVGF = FLOAT ( N * ( N - 1 )) * 0.55
        D = 0.0
        DO 40 JJ = 2, N
         DO 40 II = 2, JJ
          S = A(II-1,JJ) / ATOP
          D = S * S + D
40      CONTINUE
        DSTOP = 1.0E-06 * D
C*****
C     CALCULATE THE THRESHOLD, THRSH
C*****
        THRSH = SQRT ( D / AVGF ) * ATOP
C*****
C     START A SWEEP
C*****
50      IFLAG = 0
        DO 110 JCOL = 2, N
         JCOL1 = JCOL - 1
         DO 110 IROW = 1, JCOL1
          AIJ = A(IROW,JCOL)
C*****
C     COMPARE THE OFF-DIAGONAL ELEMENT WITH THRSH
C*****
          IF ( ABS(AIJ) .LE. THRSH ) GO TO 110
          AII = A(IROW,IROW)
          AJJ = A(JCOL,JCOL)
          S = AJJ - AII
C*****
C     CHECK TO SEE IF  THE CHOSEN ROTATION IS LESS THAN THE ROUNDING
C     IF SO, THEN DO NOT ROTATE.
C*****
          IF ( ABS(AIJ) .LE. 1.0E-09 * ABS(S) ) GO TO 110
          IFLAG = 1
C*****
C     IF THE ROTATION IS VERY CLOSE TO 45 DEGREES, SET SIN AND COS
C        TO 1/(ROOT 2).
C*****
          IF ( 1.0E-10 * ABS(AIJ) .GE. ABS(S) ) THEN
           S = .707106781
           C = S
          ELSE
C*****
C     CALCULATION OF SIN AND COS FOR A ROTATION THAT IS NOT VERY CLOSE
C     TO 45 DEGREES.
C     COS = C, SIN = S
C*****
           T = AIJ / S
           S = 0.25 / SQRT ( 0.25 + T * T )
           C = SQRT ( 0.5 + S )
           S = 2.0 * T * S / C
          ENDIF
C*****
C     CALCULATION OF THE NEW ELEMENTS OF MATRIX A
C*****
          DO 60 I = 1, IROW
           T = A(I,IROW)
           U = A(I,JCOL)
           A(I,IROW) = C * T - S * U
           A(I,JCOL) = S * T + C * U
60        CONTINUE
          I2 = IROW + 2
          IF ( I2 .LE. JCOL ) THEN
           DO 70 I = I2, JCOL
            T = A(I-1,JCOL)
            U = A(IROW,I-1)
            A(I-1,JCOL) = S * U + C * T
            A(IROW,I-1) = C * U - S * T
70         CONTINUE
          ENDIF
          A(JCOL,JCOL) = S * AIJ + C * AJJ
          A(IROW,IROW) = C * A(IROW,IROW) -
     1                 S * ( C * AIJ - S * AJJ )
          DO 80 J = JCOL, N
           T = A(IROW,J)
           U = A(JCOL,J)
           A(IROW,J) = C * T - S * U
           A(JCOL,J) = S * T + C * U
80        CONTINUE
C*****
C     ROTATION COMPLETED.
C     SEE IF EIGENVECTORS ARE WANTED BY USER.
C*****
          IF ( IEGEN .EQ. 0 ) THEN
           DO 90 I = 1, N
            T = EIVR(I,IROW)
            EIVR(I,IROW) = C * T - EIVR(I,JCOL) * S
            EIVR(I,JCOL) = S * T + EIVR(I,JCOL) * C
90         CONTINUE
          ENDIF
C*****
C     CALCULATE THE NEW NORM D AND COMPARE WITH DSTOP
C*****
          S = AIJ / ATOP
          D = D - S * S
          IF ( D .LT. DSTOP ) THEN
C*****
C     RECALCULATE DSTOP AND THRSH TO DISCARD ROUNDING ERRORS
C*****
           D = 0.0
           DO 100 JJ = 2, N
            DO 100 II = 2, JJ
             S = A(II-1,JJ) / ATOP
             D = S * S + D
100        CONTINUE
           DSTOP = 1.0E-06 * D
          ENDIF
          THRSH = SQRT ( D / AVGF ) * ATOP
110     CONTINUE
        IF ( IFLAG .NE. 0 ) GO TO 50
C*****
C     ARRANGE THE EIGENVALUES IN THE ORDER OF INCREASING ENERGY.
C     ARRANGE THE EIGENVECTORS IN THE SAME ORDER.
C*****
        NU = N
        DO 140 I = 1, N
         IF ( I .GE. NU ) RETURN
         AMIN = A(I,I)
         DO 130 J = I, NU
          IF ( A(J,J) .GE. AMIN ) GO TO 130
C*****
C     IF IEGEN IS -1, EXCLUDE UNCONVERGED EIGENVALUES FROM THIS ORDERING
C*****
          TEMP = ABS (EIVR(N,J)) + ABS (EIVR(N-1,J))
          IF ( TEMP .GT. 0.05 .AND. IEGEN .EQ. -1 ) THEN
           TEMP = A(J,J)
           A(J,J) = A(NU,NU)
           A(NU,NU) = TEMP
           II = NU
           NU = NU - 1
          ELSE
           II = I
           AMIN = A(J,J)
           A(J,J) = A(I,I)
           A(I,I) = AMIN
          ENDIF
          DO 120 K = 1, N
           TEMP = EIVR(K,II)
           EIVR(K,II) = EIVR(K,J)
           EIVR(K,J) = TEMP
120       CONTINUE
130      CONTINUE
140     CONTINUE
        RETURN
        END
